﻿#Assuming we are now in safe mode 
#Script should run cleaner
#set to boot in normal mode
#then reboot the pc


function IsSafeMode 
    {
     $bootMode = (Get-WmiObject -Class Win32_ComputerSystem).BootupState
     if ($bootMode -eq "Fail-safe with network boot") 
        {
        return $true
        } 
     else 
        {
        return $false
        }
    }

function SetNormalMode 
    {
    bcdedit /deletevalue safeboot
    }


function SetSafeMode 
    {
    bcdedit /set safeboot minimal
    }


function RunAndWaitForProgram {
    param (
        [string]$ProgramPath
    )

    $process = Start-Process -FilePath $ProgramPath -PassThru
    $process.WaitForExit()

    if ($process.ExitCode -ne 0) {
        Write-Host "The program exited with error code $($process.ExitCode)."
        return $process.ExitCode
    } else {
        return 0
    }
}

Function SuspendBitlocker {
	$x = Suspend-BitLocker -MountPoint "C:" -RebootCount 4
	return $X.ProtectionStatus
}

#Puts pc back into boot to normal mode
    SetNormalMode

#Schedules the pc to boot in 30 minutes in case something goes wrong
    shutdown /r /f /t 1800


#Runs the S1 Cleaner
    $programPath = "C:\Temp\Cleaners\SentinelCleaner_22_1GA_64.exe"
    $exitCode = RunAndWaitForProgram -ProgramPath $programPath

    if ($exitCode -ne 0) {
        Write-Host "The program exited with error code $exitCode."
    } else {
        Write-Host "The program completed successfully."
    }

#Remove auto login registry keys
$RegPath = "HKLM:\SOFTWARE\Microsoft\Windows NT\CurrentVersion\Winlogon"
Set-ItemProperty $RegPath "AutoAdminLogon" -Value "0" -type String 
Start-Sleep -Seconds 5
Set-ItemProperty $RegPath "DefaultUsername" -Value "" -type String 
Start-Sleep -Seconds 5
Set-ItemProperty $RegPath "DefaultPassword" -Value "" -type String 
Start-Sleep -Seconds 5

#Clean up downloads and folders created earlier
Remove-Item 'C:\Temp\Cleaners' -Recurse -Force
Start-Sleep -Seconds 5
Remove-Item -Path 'C:\Temp\SafeModeScript.zip' -Force
Start-Sleep -Seconds 5
Remove-Item -Path 'C:\Temp\SafeModeScript.ps1' -Force
Start-Sleep -Seconds 5
Remove-Item -Path 'C:\Temp\Cleaners_22_1.zip' -Force
Start-Sleep -Seconds 5

#Reenable legal login notice
Rename-ItemProperty -Path HKLM:\SOFTWARE\Microsoft\Windows\CurrentVersion\Policies\System -Name LegalNoticeCaption.old -NewName LegalNoticeCaption

#Resume BitLocker
Resume-BitLocker -MountPoint "C:"
Start-Sleep -Seconds 5

#Runs Reboot now.
Shutdown /A
Start-Sleep -Seconds 5
shutdown /r /f /t 10


#Confirm pc is in safe mode and exit if not, otherwise proceed

